﻿using System;
using System.Collections.Generic;
using System.ComponentModel;
using System.Data;
using System.Drawing;
using System.Text;
using System.Windows.Forms;
using System.Reflection;

namespace EaWorkflowDesignerAddin.Ui
{
    public partial class About : Form
    {
        public About()
        {
            InitializeComponent();
            CustomInitialize();
        }

        private void CustomInitialize()
        {
            Assembly asm = Assembly.GetExecutingAssembly();
            string fullVersionSpec = asm.FullName.Split(',')[1];
            string version = fullVersionSpec.Substring(fullVersionSpec.IndexOf('=') + 1);

            lblVersion.Text = "Version: " + version;

        }

        private void btnClose_Click(object sender, EventArgs e)
        {
            Close();
        }
    }
}
