﻿using System;

using WorkflowService.Model;
using WorkflowService.Model.DatabaseSpecific;

namespace WorkflowService
{
    public class WorkflowServiceImpl : IWorkflowService
    {
        private static Guid UNSAVED_GUID = new Guid("00000000-0000-0000-0000-000000000000");
        private DataAccessAdapter _adapter;

        public WorkflowServiceImpl()
        {
            DataAccessAdapter _adapter = new DataAccessAdapter();
        }


        #region IWorkflowService Members

        public Guid PersistWorkflowInstance(WorkflowInstance instance)
        {
            if (instance.Guid == UNSAVED_GUID)
            {
                instance.Guid = Guid.NewGuid();
            }
            _adapter.SaveEntity(instance);
            return instance.Guid;
        }

        public WorkflowInstance FetchWorkflowInstance(Guid instanceId)
        {
            throw new NotImplementedException();
        }

        #endregion
    }
}
